import type { GetReleasesConfig, ReleaseResult } from '../types';
export declare const id = "crate";
export declare const defaultRegistryUrls: string[];
export declare const defaultVersioning = "cargo";
export declare const registryStrategy = "first";
export declare enum RegistryFlavor {
    /** https://crates.io, supports rawgit access */
    CratesIo = 0,
    /** https://cloudsmith.io, needs git clone */
    Cloudsmith = 1,
    /** unknown, assuming private git repository */
    Other = 2
}
export interface RegistryInfo {
    flavor: RegistryFlavor;
    /** raw URL of the registry, as specified in cargo config */
    rawUrl?: string;
    /** parsed URL of the registry */
    url?: URL;
    /** path where the registry is cloned */
    clonePath?: string;
}
export declare function getIndexSuffix(lookupName: string): string[];
export declare function fetchCrateRecordsPayload(info: RegistryInfo, lookupName: string): Promise<string>;
export declare function areReleasesCacheable(registryUrl: string): boolean;
export declare function getReleases(config: GetReleasesConfig): Promise<ReleaseResult | null>;
