import type { DatasourceApi, DigestConfig, GetPkgReleasesConfig, ReleaseResult } from './types';
export * from './types';
export { isGetPkgReleasesConfig } from './common';
export declare const getDatasources: () => Map<string, DatasourceApi>;
export declare const getDatasourceList: () => string[];
export declare function getDefaultVersioning(datasourceName: string): string;
export declare function getPkgReleases(config: GetPkgReleasesConfig): Promise<ReleaseResult | null>;
export declare function supportsDigests(config: DigestConfig): boolean;
export declare function getDigest(config: DigestConfig, value?: string): Promise<string | null>;
export declare function getDefaultConfig(datasource: string): Promise<Record<string, unknown>>;
