import type { Release, ReleaseResult } from '../types';
export declare function resetMemCache(): void;
export declare function resetCache(): void;
export interface NpmRelease extends Release {
    gitRef?: string;
}
export interface NpmDependency extends ReleaseResult {
    releases: NpmRelease[];
    deprecationSource?: string;
    name: string;
    homepage: string;
    sourceUrl: string;
    versions: Record<string, any>;
    'dist-tags': Record<string, string>;
    'renovate-config': any;
    sourceDirectory?: string;
}
export interface NpmResponse {
    _id: string;
    name?: string;
    versions?: Record<string, {
        repository?: {
            url: string;
            directory: string;
        };
        homepage?: string;
        deprecated?: boolean;
        gitHead?: string;
        dependencies?: Record<string, string>;
        devDependencies?: Record<string, string>;
    }>;
    repository?: {
        url?: string;
        directory?: string;
    };
    homepage?: string;
    time?: Record<string, string>;
}
export declare function getDependency(packageName: string, retries?: number): Promise<NpmDependency | null>;
