"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseReport = exports.getExtractFile = void 0;
const path_1 = require("path");
const upath_1 = require("upath");
const data_files_generated_1 = __importDefault(require("../../data-files.generated"));
const fs_1 = require("../../util/fs");
// need to match filename in `data/extract.py`
const REPORT = 'renovate-pip_setup-report.json';
const EXTRACT = 'renovate-pip_setup-extract.py';
let extractPy;
async function getExtractFile() {
    if (extractPy) {
        return extractPy;
    }
    const cacheDir = await fs_1.ensureCacheDir('./others/pip_setup');
    extractPy = upath_1.join(cacheDir, EXTRACT);
    await fs_1.outputFile(extractPy, data_files_generated_1.default.get('extract.py'));
    return extractPy;
}
exports.getExtractFile = getExtractFile;
async function parseReport(packageFile) {
    const data = await fs_1.readLocalFile(upath_1.join(path_1.dirname(packageFile), REPORT), 'utf8');
    return JSON.parse(data);
}
exports.parseReport = parseReport;
//# sourceMappingURL=util.js.map