"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.bumpPackageVersion = void 0;
const semver_1 = require("semver");
const logger_1 = require("../../logger");
function bumpPackageVersion(content, currentValue, bumpVersion) {
    logger_1.logger.debug({ bumpVersion, currentValue }, 'Checking if we should bump build.sbt version');
    let bumpedContent = content;
    const bumpedVersion = semver_1.inc(currentValue, bumpVersion);
    if (!bumpedVersion) {
        logger_1.logger.warn('Version incremental failed');
        return { bumpedContent };
    }
    bumpedContent = content.replace(/^(version\s*:=\s*).*$/m, `$1"${bumpedVersion}"`);
    if (bumpedContent === content) {
        logger_1.logger.debug('Version was already bumped');
    }
    else {
        logger_1.logger.debug({ bumpedVersion }, 'Bumped build.sbt version');
    }
    return { bumpedContent };
}
exports.bumpPackageVersion = bumpPackageVersion;
//# sourceMappingURL=update.js.map