import { BranchStatus, VulnerabilityAlert } from '../../types';
import type { BranchStatusConfig, CreatePRConfig, EnsureCommentConfig, EnsureCommentRemovalConfig, EnsureIssueConfig, EnsureIssueResult, FindPRConfig, Issue, PlatformResult, Pr, RepoParams, RepoResult, UpdatePrConfig } from '../types';
export declare function initPlatform({ endpoint, token, username, gitAuthor, }: {
    endpoint: string;
    token: string;
    username?: string;
    gitAuthor?: string;
}): Promise<PlatformResult>;
export declare function getRepos(): Promise<string[]>;
export declare function getJsonFile(fileName: string): Promise<any | null>;
export declare function initRepo({ endpoint, repository, forkMode, forkToken, localDir, renovateUsername, cloneSubmodules, ignorePrAuthor, }: RepoParams): Promise<RepoResult>;
export declare function getRepoForceRebase(): Promise<boolean>;
export declare function getPr(prNo: number): Promise<Pr | null>;
export declare function getPrList(): Promise<Pr[]>;
export declare function findPr({ branchName, prTitle, state, }: FindPRConfig): Promise<Pr | null>;
export declare function getBranchPr(branchName: string): Promise<Pr | null>;
export declare function getBranchStatus(branchName: string, requiredStatusChecks: any[] | undefined): Promise<BranchStatus>;
export declare function getBranchStatusCheck(branchName: string, context: string): Promise<BranchStatus | null>;
export declare function setBranchStatus({ branchName, context, description, state, url: targetUrl, }: BranchStatusConfig): Promise<void>;
export declare function getIssueList(): Promise<Issue[]>;
export declare function findIssue(title: string): Promise<Issue | null>;
export declare function ensureIssue({ title, reuseTitle, body: rawBody, once, shouldReOpen, }: EnsureIssueConfig): Promise<EnsureIssueResult | null>;
export declare function ensureIssueClosing(title: string): Promise<void>;
export declare function addAssignees(issueNo: number, assignees: string[]): Promise<void>;
export declare function addReviewers(prNo: number, reviewers: string[]): Promise<void>;
export declare function deleteLabel(issueNo: number, label: string): Promise<void>;
export declare function ensureComment({ number, topic, content, }: EnsureCommentConfig): Promise<boolean>;
export declare function ensureCommentRemoval({ number: issueNo, topic, content, }: EnsureCommentRemovalConfig): Promise<void>;
export declare function createPr({ sourceBranch, targetBranch, prTitle: title, prBody: rawBody, labels, draftPR, }: CreatePRConfig): Promise<Pr>;
export declare function updatePr({ number: prNo, prTitle: title, prBody: rawBody, state, }: UpdatePrConfig): Promise<void>;
export declare function mergePr(prNo: number, branchName: string): Promise<boolean>;
export declare function massageMarkdown(input: string): string;
export declare function getVulnerabilityAlerts(): Promise<VulnerabilityAlert[]>;
