import { BranchStatus, VulnerabilityAlert } from '../../types';
import type { BranchStatusConfig, CreatePRConfig, EnsureCommentConfig, EnsureCommentRemovalConfig, EnsureIssueConfig, FindPRConfig, Issue, PlatformParams, PlatformResult, Pr, RepoParams, RepoResult, UpdatePrConfig } from '../types';
import type { GitlabIssue } from './types';
export declare function initPlatform({ endpoint, token, }: PlatformParams): Promise<PlatformResult>;
export declare function getRepos(): Promise<string[]>;
export declare function getJsonFile(fileName: string): Promise<any | null>;
export declare function initRepo({ repository, localDir, cloneSubmodules, ignorePrAuthor, }: RepoParams): Promise<RepoResult>;
export declare function getRepoForceRebase(): Promise<boolean>;
export declare function getBranchStatus(branchName: string, requiredStatusChecks?: string[] | null): Promise<BranchStatus>;
export declare function getPrList(): Promise<Pr[]>;
export declare function createPr({ sourceBranch, targetBranch, prTitle, prBody: rawDescription, draftPR, labels, platformOptions, }: CreatePRConfig): Promise<Pr>;
export declare function getPr(iid: number): Promise<Pr>;
export declare function updatePr({ number: iid, prTitle, prBody: description, state, platformOptions, }: UpdatePrConfig): Promise<void>;
export declare function mergePr(iid: number): Promise<boolean>;
export declare function massageMarkdown(input: string): string;
export declare function findPr({ branchName, prTitle, state, }: FindPRConfig): Promise<Pr>;
export declare function getBranchPr(branchName: string): Promise<Pr>;
export declare function getBranchStatusCheck(branchName: string, context: string): Promise<BranchStatus | null>;
export declare function setBranchStatus({ branchName, context, description, state: renovateState, url: targetUrl, }: BranchStatusConfig): Promise<void>;
export declare function getIssueList(): Promise<GitlabIssue[]>;
export declare function findIssue(title: string): Promise<Issue | null>;
export declare function ensureIssue({ title, reuseTitle, body, }: EnsureIssueConfig): Promise<'updated' | 'created' | null>;
export declare function ensureIssueClosing(title: string): Promise<void>;
export declare function addAssignees(iid: number, assignees: string[]): Promise<void>;
export declare function addReviewers(iid: number, reviewers: string[]): Promise<void>;
export declare function deleteLabel(issueNo: number, label: string): Promise<void>;
export declare function ensureComment({ number, topic, content, }: EnsureCommentConfig): Promise<boolean>;
export declare function ensureCommentRemoval({ number: issueNo, topic, content, }: EnsureCommentRemovalConfig): Promise<void>;
export declare function getVulnerabilityAlerts(): Promise<VulnerabilityAlert[]>;
